' I2CREAD and I2WRITE Commands
' RTC  PCF 8583P 
' Read And Write SECOND , MINUTE , HOURS to RTC chip 
' Note: Send Second , Minute , Hours to RS232 Port Boardrate 9600

        INCLUDE "modedefs.bas"          ' Include serial modes

SO      VAR     PORTC.6                       ' Define serial output pin
SI      VAR     PORTC.7
DPIN    VAR     PORTC.4                 ' I2C data pin
CPIN    VAR     PORTC.3                 ' I2C clock pin
first   VAR     BYTE
second  VAR     BYTE
B1      VAR     BYTE
B2      VAR     BYTE
B3      VAR     BYTE
B_H     VAR     BYTE
B_L     VAR     BYTE
BB      VAR     BYTE
DEFINE  OSC     10

            serout SO,T9600,[12,"Press 's' for set timer or 'd' for display",10,13]
            
now:        serin SI,T9600,BB
            if BB = "s" or "S" then  set_time
            if BB = "d" or "S" then
                goto display
            else 
                goto now
            endif
            
set_time:   serout SO,T9600,["hour(0-24) = "]
            gosub   get_key
            B3 = BB
            serout SO,T9600,["min (0-59) = "]
            gosub   get_key
            B2 = BB
            serout SO,T9600,["sec(0-59) = "]
            gosub   get_key
            B1 = BB
            
                I2CWrite DPIN,CPIN,$A2,$00,[$00,$00,B1,B2,B3]  ' Write each location's address to itself
                Pause 10                ' Delay 10ms after each write
                    
display:        I2CRead DPIN,CPIN,$A2,02,[B1,B2,B3]        ' Read 2 locations in a row
                pause 10
                BB = B3
                GOSUB CONV
                SerOut SO,T9600,[12,#B_H,#B_L," : "]
                BB = B2
                GOSUB CONV
                SerOut SO,T9600,[#B_H,#B_L," : "]
                BB = B1
                GOSUB CONV
                SerOut SO,T9600,[#B_H,#B_L,10,13,10,10,"Press 'S' to set time",10,13]
                    
        serin SI,T9600,200,display,BB
            if BB = "s" or "S" then set_time
         
        GoTo display
        
get_key:    serin SI,T9600,first
            
                if (first < "0") or (first >"9") then get_key
             serout SO,T9600,[first]   
            first = first - "0"
            
new:      serin SI,T9600,second          
                if (second < "0") or (second > "9") then new 
           serout SO,T9600,[second,10,13]        
            BB = (first << 4) | (second -"0")
            return  
        
CONV:           B_L = BB & %00001111
                B_H = BB & %11110000 
                B_H = B_H >> 4 
                
                RETURN
