;**************************************
; Test  Speaker PORTB.5
; Hardware  : CP-PIC V4.0
; OSC	    : 10 MHz [HS mode]
; Assembler : mpasm.exe
; Programmer: Watcharin Kaorop
; Company   : ETT  CO.,LTD.
; Date      : 28/7/2002
;**************************************

     list p=18f442                 ; list directive to define processor
     #include <p18f442.inc>        ; processor specific variable definitions

 CONFIG  OSC = HS,PWRT = ON,WDT = OFF,LVP = OFF

#define   SPK       PORTB,2        ; PORTB.2

count	  EQU	    0x20
count1    EQU       0x22
count2    EQU       0x23
count3    EQU       0x24
count16   EQU	    0x25

          ORG       0x0000
          
	  clrf      TRISB          ; All port B is output
loop:	  call	    pulse
	  bcf	    SPK		   ; off sound
	  call	    delay2
	  goto	    loop

pulse:	  clrf	    count
pul:	  bcf	    SPK      ; __   __
	  call	    delay    ;   |_|  |__
	  bsf	    SPK
	  call	    delay
	  decfsz    count
	  goto	    pul
	  return	 



;***************************************
; Delay 
;***************************************
delay     movlw     .5
          movwf     count1
del1      clrf      count2
del2      decfsz    count2
          goto      del2
          decfsz    count1
          goto      del1
          return

delay2    movlw     .5
          movwf     count1
dely	  clrf	    count2
dely1     clrf      count3
dely2     decfsz    count3
          goto      dely2
          decfsz    count2
          goto      dely1
	  decfsz    count1
	  goto	    dely
          return

          END

